<template>
  <NuxtLayout :name="'dashboard'">
    <div class="container p-8">
      <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
      <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
        :items="files" :addPath="'/upload'" @on-search="search" @download-file="downloadFile" @delete-file="deleteFile"
        @page-change="pageUpdate" />
    </div>
  </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
  middleware: ["auth"],
});

export default {
  layout: "dashboard",
  data() {
    return {
      toastVisible: false,
      toastTitle: "",
      toastMessage: "",
      tableName: "Files",
      isLoading: false,
      currentPage: 1,
      itemPerPage: 10,
      heads: [
        "No",
        "Title",
        "Description",
        "Created At",
        "Owner Name",
        "Owner Email",
        "Action",
      ],
      files: [],
    };
  },
  mounted() {
    this.fetchData();
  },
  methods: {
    fetchData(query: string = '') {
      this.isLoading = true;
      const toastStore = useToastStore();
      const config = useRuntimeConfig();
      this.$api
        .get(`/file?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("access_token")}`,
          },
        })
        .then((response) => {
          let datas = response.data;
          datas.map((item: any) => {
            item.date = new Date(item.created_at).toISOString().split('T')[0];
            item.owner_name = item.owner.name;
            item.owner_email = item.owner.email;
            delete item.owner;
            delete item.created_at;
            item.action = [
              {
                icon: "material-symbols:edit-outline",
                color: "bg-blue-500",
                route: `/files/${item.id}`,
                disabled: false
              },
              {
                icon: "material-symbols:cloud-download-outline-rounded",
                color: "bg-green-500",
                disabled: item.file_path ? false : true,
                callback: 'download-file',
              },
              {
                icon: "material-symbols:delete-outline-rounded",
                color: "bg-red-500",
                disabled: false,
                callback: 'delete-file',
              },
            ];
            delete item.file_path;
          });
          this.files = datas;
        })
        .catch((error) => {
          console.log(error);
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger');
        }).finally(() => {
          this.isLoading = false;
        })
    },
    search(query: string) {
      this.fetchData(query);
    },
    addFile() {
      // Add your logic for creating a new file
    },
    editFile(data: any) {
      // Add your logic for editing a file
      console.log(data)
    },
    async downloadFile(id: number) {
      const toastStore = useToastStore();
      try {
        const response = await this.$api.get(`/file/download/${id}`, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem('access_token')}`,
          },
          responseType: 'blob', // Important to handle binary data like a PDF
        });

        const url = window.URL.createObjectURL(new Blob([response.data]));
        const link = document.createElement('a');
        link.href = url;
        link.setAttribute('download', 'downloaded_file.pdf');
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
      } catch (error: any) {
        console.error('Error downloading PDF:', error);
        if (error.response.status == 404)
          toastStore.showToast('File tidak ditemukan!', 'danger');
        else
          toastStore.showToast(error.response.data.detail, 'danger');
      }
    },
    pageUpdate(page: number) {
      this.currentPage = page;
      this.fetchData();
    },
    deleteFile(id: number) {
      // Add your logic for deleting a file
      console.log('delete')
      console.log(id)
      this.isLoading = true;
      const toastStore = useToastStore();
      this.$api.delete(`/file/${id}`, {
        headers: {
          Authorization: `Bearer ${localStorage.getItem("access_token")}`,
        },
      })
        .then((response) => {
          console.log(response)
          let title = response.data.title;
          this.isLoading = false;
          this.fetchData();
          toastStore.showToast(`Dokumen ${title} telah dihapus`, 'success');
        })
        .catch((error) => {
          console.log(error);
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          this.isLoading = false;
          this.fetchData();
          toastStore.showToast(message, 'danger');
        })
    },
  },
};
</script>
